package com.flossom.common.core.mapper;

import com.flossom.common.core.domain.entity.SysTag;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 标签管理 数据层
 *
 * @author flossom
 */
public interface SysTagMapper {
    /**
     * 查询标签管理数据
     *
     * @param tag 标签信息
     * @return 标签信息集合
     */
    public List<SysTag> selectDeptList(SysTag tag);

    /**
     * 根据角色ID查询标签树信息
     *
     * @param roleId            角色ID
     * @param deptCheckStrictly 标签树选择项是否关联显示
     * @return 选中标签列表
     */
    public List<Long> selectDeptListByRoleId(@Param("roleId") Long roleId, @Param("deptCheckStrictly") boolean deptCheckStrictly);

    /**
     * 根据标签ID查询信息
     *
     * @param id 标签ID
     * @return 标签信息
     */
    public SysTag selectDeptById(Long id);

    /**
     * 根据ID查询所有子标签
     *
     * @param id 标签ID
     * @return 标签列表
     */
    public List<SysTag> selectChildrenDeptById(Long id);

    /**
     * 根据ID查询所有子标签（正常状态）
     *
     * @param id 标签ID
     * @return 子标签数
     */
    public int selectNormalChildrenDeptById(Long id);

    /**
     * 是否存在子节点
     *
     * @param id 标签ID
     * @return 结果
     */
    public int hasChildByDeptId(Long id);

    /**
     * 查询标签是否存在用户
     *
     * @param id 标签ID
     * @return 结果
     */
    public int checkDeptExistUser(Long id);

    /**
     * 校验标签名称是否唯一
     *
     * @param tagName 标签名称
     * @param parentId 父标签ID
     * @return 结果
     */
    public SysTag checkDeptNameUnique(@Param("tagName") String tagName, @Param("parentId") Long parentId);

    /**
     * 新增标签信息
     *
     * @param tag 标签信息
     * @return 结果
     */
    public int insertDept(SysTag tag);

    /**
     * 修改标签信息
     *
     * @param tag 标签信息
     * @return 结果
     */
    public int updateDept(SysTag tag);

    /**
     * 修改所在标签正常状态
     *
     * @param deptIds 标签ID组
     */
    public void updateDeptStatusNormal(Long[] deptIds);

    /**
     * 修改子元素关系
     *
     * @param tags 子元素
     * @return 结果
     */
    public int updateDeptChildren(@Param("depts") List<SysTag> tags);

    /**
     * 删除标签管理信息
     *
     * @param id 标签ID
     * @return 结果
     */
    public int deleteDeptById(Long id);

    List<SysTag> selectSecondTagByType(@Param("type") Integer type);

    List<SysTag> selectByIdList(@Param("tagIdList") List<Long> tagIdList);
}
